function [ Z, sigma ] = mds( D, m, alpha, epsilon, maxI)
%MDS Embeds n points into R^m such that the euclidean distance preserves D.
% Inputs:
% D       : Non-negative n-by-n matrix containing the distances between 
%           points. I.e. D(i,j) contains the distance between points i,j.
%           Parameter n is given implicitely by the dimension of D.
% m       : Natural number m specifies the dimension of the embedding
%           space. If m=2 or m=3 the progress will be plotted.
% alpha   : Stepsize of the gradient descent algorithm. A value of 1e-4
%           should be fine. Experiment with this: If the values are too
%           small, the algorithm will converge very slowly. If the values
%           are too large, the algorithm will not converge at all.
% epsilon : Gradient descent algorithm stops after relative progress drops
%           below epsilon.
% maxI    : Gradient descent algorithm stops after at most maxI iterations.
%
% Outputs:
% Z       : n-by-m matrix Z contains the coordinates of the points in the
%           embedding space upon termination of the algorithm.
% sigma   : value of the embedding error


figure();

while (stopping criteria not fulfilled)

    %visualize intermediate results
    if (m==2)
        plot(Z(:,1),Z(:,2),'r.'); axis off, axis equal, drawnow
    end
    if (m>=3)
        plot3(Z(:,1),Z(:,2),Z(:,3),'r.'); axis off, axis equal, drawnow
    end
    
end

end

